

/**********************************************************


//		  MD210M-R,MD210C-R		  
//		          |-------------------|
//                |ANT           MOSI |--1-- 
//                |GND           SCLK |--2-- 
//                |              MISO |--3--
//                |              GDO2 |--4--
//                |              GDO0 |--5--
//                |               CSN |--6--
//                |               GND |--7--    
//                | GND           VDD |--8--
//                | ------------------|  
//      
 		       CHIP:CC113L

**********************************************************/


//==================APP DEFINE==========
/*               		    TSSOP20


 FOR TI RX module
                              |-------\_/-------|
              PWM3/RLED ---1--|P00           P01|--20--- SCLK 
           CK/PWM2/BZ_O ---2--|P17           P02|--19--- 
           DA/PWM1      ---3--|P16           P03|--18--- 
                        ---4--|/RST          P04|--17--- 
                        ---5--|Vss  N79E814  P05|--16--- 
                 NC  	---6--|P31           Vdd|--15---   
                MOSI	---7--|P30           P06|--14--- 
                MISO   	---8--|P14           P07|--13--- GDO0                 
                CHR_IN	---9--|P13           P10|--12--- nSEL
                NC  	---10-|P12           P11|--11---
                              |_________________|
					   //P12,P13 OPEN DRAIN!!!!!!!!
*/	
/**********************************************************
IO port define

**********************************************************/

#define RLED		P00	//pwm3
#define SCK 		P01	//pwm0


#define GPIO0 	    P07	//KBI.7

#define nSEL 		P10

#define MISO		P14
//#define NC        P16


#define MOSI		P30
//#define NC	    P31



//                   


/**********************************************************
**Constant define
**********************************************************/


#define c_rfwindows 6//5		//120ms		   4:6
#define c_rf_off_time 18//10  	   //240ms;15


#define KBI_Enable          0xFF
#define KBI_Level           0x00

//CommandStrobe

#define  SRES     	 0x30 					//λϵ縴λ
#define  SFSTXON  	 0x31					//	
#define  SXOFF    	 0x32					//رվ
#define  SCAL     	 0x33					//
#define  SRX      	 0x34 					//RXģʽ
#define  STX      	 0x35 					//TXģʽ
#define  SIDLE    	 0x36					//ģʽ˳RX/TX
#define  SAFC     	 0x37 					//
#define  SWOR     	 0x38					//Wake-on-Radio Mode
#define  SPWD     	 0x39					//ģʽȴCSnߺ
#define  SFRX     	 0x3a					//Flush RX FIFO
#define  SFTX     	 0x3b					//Flush TX FIFO 
#define  SWORRST  	 0x3c 					//λRTC
#define  SNOP     	 0x3d					//ղ


//CC1100Reg

#define  IOCFG2  	 0x00					//GDO2
#define  IOCFG1  	 0x01					//GDO1
#define  IOCFG0	 	 0x02					//GDO0
#define  FIFOTHR 	 0x03					//RX FIFO and TX FIFO
#define  SYNC1   	 0x04					//Sync word high byte
#define  SYNC0   	 0x05					//Sync wore low byte
#define  PKTLEN  	 0x06 					//Packet length
#define  PKTCTRL1	 0x07					//Packet automation control
#define  PKTCTRL0	 0x08 					//Packet automation control
#define  ADDR    	 0x09					//Device address
#define  CHANNR  	 0x0a					//Channel number 
#define  FSCTRL1 	 0x0b					//Frequency synthesizer control
#define  FSCTRL0 	 0x0c					//Frequency synthesizer control
#define  FREQ2   	 0x0d					//Frequency control word, high byte
#define  FREQ1   	 0x0e					//Frequency control word, middle byte
#define  FREQ0   	 0x0f					//Frequency control word, low byte
#define  MDMCFG4 	 0x10					//Modern configuration
#define  MDMCFG3 	 0x11					//Modern configuration
#define  MDMCFG2 	 0x12					//Modern configuration
#define  MDMCFG1 	 0x13					//Modern configuration
#define  MDMCFG0 	 0x14					//Modern configuration
#define  DEVIATN 	 0x15					//Modern deviation setting
#define  MCSM2   	 0x16					//Main Radio Control State Machine configuration
#define  MCSM1   	 0x17					//Main Radio Control State Machine configuration
#define  MCSM0   	 0x18					//Main Radio Control State Machine configuration
#define  FOCCFG  	 0x19					//Frequency Offset Compensation configuration
#define  BSCFG   	 0x1a 					//Bit Synchronization configuration 
#define  AGCTRL2 	 0x1b 					//AGC control
#define  AGCTRL1 	 0x1c 					//AGC control
#define  AGCTRL0 	 0x1d 					//AGC control
#define  WOREVT1 	 0x1e					//High byte Event 0 timeout
#define  WOREVT0 	 0x1f					//Low byte Event 0 timeout
#define  WORCTRL 	 0x20					//Wake On Radio Control
#define  FREND1  	 0x21 					//Front and RX configuration
#define  FREND0  	 0x22 					//Front and TX configuration
#define  FSCAL3  	 0x23 					//Frequency synthesizer
#define  FSCAL2  	 0x24 					//Frequency synthesizer
#define  FSCAL1  	 0x25 					//Frequency synthesizer
#define  FSCAL0  	 0x26 					//Frequency synthesizer
#define  RCCTRL1 	 0x27 					//RC oscillator configuration
#define  RCCTRL0 	 0x28 					//RC oscillator configuration
#define  FSTEST  	 0x29 					//Frequency synthesizer calibration control
#define  PTEST   	 0x2a 					//Frequency synthesizer calibration control 
#define  AGCTEST 	 0x2b 					//AGC Test
#define  TEST2   	 0x2c					//Various test settings
#define  TEST1   	 0x2d					//Various test settings
#define  TEST0   	 0x2e					//Various test settings

#define  PARTNUM 	 0x30					//ע± 0xC0+
#define  VERSION 	 0x31 					//Ҳд
#define  FREQEST 	 0x32 
#define  LQI     	 0x33
#define  RSSI    	 0x34 
#define MARCSTATE	 0x35 
#define  WORTIME1	 0x36 
#define  WORTIME0	 0x37 
#define PKTSTATUS	 0x38
#define VCO_VC_DAC	 0x39
#define  TXBYTES 	 0x3a
#define  RXBYTES 	 0x3b
#define  PATABLE 	 0x3e
#define  TXFIFO  	 0x3f
#define  RXFIFO  	 0x3f


//FSMState							//MARCSTATE5λ

#define  RFSLEEP   	 0x00			//
#define  IDLE    	 0x01 			//
#define  XOFF    	 0x02			//XOFF
#define  VCOON_MC	 0x03			//Mancal
#define  REGON_MC	 0x04 			//Mancal
#define  MANCAL	 	 0x05 			//Mancal
#define  VCCON   	 0x06 			//FS_Wakeup
#define  REGON   	 0x07 			//FS_Wakeup
#define  STARTCAL	 0x08			//CALIBRATE
#define  BWBOOST 	 0x09 			//Setting
#define  FS_LOCK 	 0x0a 			//Setting
#define  IFADCON 	 0x0b 			//Setting
#define  ENDCAL  	 0x0c 			//CALIBRATE
#define  RX	     	 0x0d 			//RX
#define  RX_END  	 0x0e 			//RX
#define  RX_RST  	 0x0f 			//RX
#define TXRX_SWITCH  0x10 			//TXRX_Setting
#define  RX_OVERFLOW 0x11 			//RX_Overflow
#define  FSTXON      0x12 			//FSTXON
#define  TX          0x13 			//TX
#define  TX_END      0x14 			//TX_END
#define RXTX_SWITCH  0x15 			//RXTX_Setting
#define TX_UNDERFLOW 0x16			//TX_Underflow

//GDO Status
#define	RX_IRQ_SAME	 0x00			//ֵ1Сڵֵ
#define RX_IRQ_EMPT	 0x01			//ֵ1FIFOʱ
#define	TX_IRQ_SAME	 0x02			//ֵ1Сڵֵ
#define	TX_IRQ_FULL	 0x03			//FIFO
#define	RX_IRQ_OVF	 0x04			//FIFO Rx
#define	TX_IRQ_OVF	 0x05			//FIFO Tx
#define RX_IRQ_CRC_OK    0x07//0x0f //0x07                   //received one packet and CRC OK
#define	RX_DATA		 0x0D  			//ֱͨģʽ
#define	HIGH_IMP	 0x2E			//3̬

//Work Mode
#define	TEST_TX		 0x00
#define	TEST_RX		 0x01
#define	NORMAL_TX	 0x02
#define	NORMAL_RX	 0x03

//PH+FIFO
#define	PKLENGTH	 6 //0x11



/**********************************************************
**Extern variable define(RAM define)
**********************************************************/

u8  gb_Temp[5];
u8  gb_RxData[10]; //Receive data buffer


u8  gb_EA_bit_bak;

u8 gb_learn_flag;
u8 gb_ac_en_flag;
u8 gb_mo_en_flag;
u8 gb_bz_en_flag;
u8 gb_lt_en_flag;
u8 gb_en_rx_flag;
u8 gb_tx_onoff_cmd_flag;
u8 gb_rf_scan_flag;
u8 gb_stop_pwm_flag;
u8 gb_key_press_flag;
u8 gb_key_hold_flag;
u8 gb_unit_on_flag;
u8 gb_KBI_int_flag;
u8 gb_lb_test_flag;
u8 f_low_bat;
u8 f_768_880;

u8 gb_charge_flag;

u8 gb_auto_sleep_flag;
u8 f_en_det_charge;
bit f_lt_en;

u8 gb_rf_windows;
u8 gb_rf_off_time;
u8 gb_sec_cnt;
u16 gb_auto_sleep_cnt;
u8 gb_key_hold_cnt;
u8 gb_bat_status;
u8 gb_bat_off_cnt;
u16 lamp_on_cnt;

u8 gb_LocalIDL;
u8 gb_LocalIDM;
u8 gb_LocalIDH;

u16 PWM_shadow;

u8 bi_on_cnt;
u8 bi_step;
u8 bi_off_cnt;
u8 bi_times;
u8 gb_safe_off_fast_cnt;
u8 gb_safe_off_slow_cnt;

u8 gb_ac_pulse_cnt;
u8 gb_acmo_level;
u8 gb_acmo_duration_cnt;
u8 gb_bz_duration_cnt;
u8 gb_bz_output_step;
u8 gb_dis_rx_cmd_cnt;
u8 gb_Rxmode;
u8 gb_acmo_period_cnt;
u8 gb_acmo_period_cnt_bak;
u8 gb_acmo_duty_cnt;

u8 gb_acmo_step;
u8 gb_TH0;
u8 gb_TL0;

u8 gb_learn_cnt;

u8 gb_led_on_time;
u8 gb_led_on_step;
u8 gb_led_on_step;
u8 gb_led_duration_cnt;
u8 gb_wr2;

u16 gb_ADCL;
u16 gb_ADC;
u8 gb_ADC_sample_cnt;

u8 gb_LED_flash_cnt;
u8 gb_RLED_flash_duration_cnt;

//u32 u32Baudrate;

u8 gb_key_name;
u8 gb_key_debounce_time;
u8 gb_key_debounce_flag;

u8 gb_charge_debounce_time;
u8 gb_charge_debounce_flag;

u8 gb_off_scan_cnt;
u8 gb_Model;
u8 gb_TransID;
u8 gb_TransID_temp;



u8 f_unit_on;
u8 f_key_release;
u8 f_en_tx;
u8 f_fast_hold;
u8 f_hold_key;
u8 f_en_key_scan;
u8 f_bat_test;
u8 f_dc_plug;
//u8 f_en_detect_dc;
u8 f_lamp_on;
u8 f_charge_ic_high;
//u8 f_quater;
u8 f_wake_up;

u32 rfconfig;
u32 rffreq;
u8 idl;
u8 idm;
u8 idh;
u8 transID;

u8 acmo_level;
u8 gb_mode;


u8 ch_no;


u8 rf_crc;
u8 gb_wr2;
u8 tx_packet_time;

u8 tx_step;
u8 txpoint;
u8 tx_max_time;
u8 txbuf[10];




