


/**********************************************************

**********************************************************/
const u8 PATable[4][4] = {
						//	0dBm  5dBm  7dBm  10dBm
	                       {0x8E, 0xCD, 0xC7, 0xC0},	//915MHz
	                       {0x50, 0x81, 0xCB, 0xC2},	//868MHz
	                       {0x60, 0x84, 0xC8, 0xC0},	//434MHz
	                       {0x51, 0x85, 0xCB, 0xC2},	//315MHz	
	                       };

const u8 FreqTable[4][3] = {
	                         {0x23, 0x31, 0x3B},		//915MHz	FREQ2~FREQ0
	                         {0x21, 0x6C, 0x4E},		//869MHz
	                         {0x10, 0xB1, 0x3B},		//434MHz
	                         {0x0C, 0x1D, 0x89},		//315MHz
	                         };


const u8 FSCALTable[4] = {0xE9, 0x2A, 0x00, 0x1F};	//FSCAL3~FSCAL0

//const u8 SyncTable[2] = {0xD3, 0x91};		//SYNC1~SYNC0(used default sync word)
const u8 SyncTable[2] = {0x66, 0x99};		//SYNC1~SYNC0(used default sync word)
/**********************************************************

**********************************************************/


/************************************************
**CC1101ú
************************************************/
/************************************************
ƣ	InitCC1101
ܣ	ʼCC1101
	
ݣ	
************************************************/
void InitCC1101(void)
{

 CC1101StartUpSeq();
 SpiWriteStorbe(SIDLE);		//ģʽ	
 BurstWrite(SYNC1, SyncTable, 2);
}

/************************************************
ƣ	CC1101StartUpSeq
ܣ	CC1101λʱ򣬷SRESȴSO
	HoldCSnΪɹCSnı
ݣ	0ʱʧܣ 0ɹ
************************************************/
u8 CC1101StartUpSeq(void)		
{
 u8 i;
 
 nSEL = 1;
 _nop_();
 SCK=1;
 MOSI=0;		
 _nop_();
 
 for(i=10;i!=0;i--)		//nSEL
 	nSEL = 0;
 for(i=40;i!=0;i--)		//nSELٱ40us
 	nSEL = 1;

 for(i=200;i!=0;i--)	//ȴMISO
 	{
 	nSEL = 0;			//Ⱦȶ
 	if(!MISO)
 		break;
 	}
 if(i==0)				//ʱ
 	{
 	nSEL = 1;
 	SCK  = 0;
 	MOSI	 = 0;
 	return(0);
 	}
 else
 	{
	HalfSpiCmd(SRES);	//׼SRES
	for(i=250;i!=0;i--)	//ȴDone
		{
 		if(!MISO)		//MISO
 			break;
		}
	nSEL = 1;
 	SCK  = 0;
 	MOSI	 = 0;
	if(i==0)
 		return(0);
	else
		return(1);
 	}
}

/************************************************
ƣ	SetCC1101
ܣ	CC1101
	
ݣ	
ע		нCSnֹͣź
************************************************/
void SetCC1101(void)
{
 u8 i;
 u8 patable[8];


 //GDO 
 //SpiWriteByte(IOCFG1, HIGH_IMP);
 SpiWriteByte(IOCFG0, 0x06);
  SpiWriteByte(IOCFG2, 0x07);

 //SpiWriteByte(IOCFG1, HIGH_IMP);
 //SpiWriteByte(IOCFG0, 01);	//above fifo 
  SpiWriteByte(IOCFG0, RX_IRQ_CRC_OK);	//crc ok
 //PKL  
 SpiWriteByte(PKTLEN, PKLENGTH+3);
 //Channel 
 SpiWriteByte(CHANNR, 0x00);			
 //ģʽ  
 	        //RX
 //SpiWriteByte(PKTCTRL0, 0x70);	//Directģʽ	
		
 SpiWriteByte(PKTCTRL0, 0x05);	//whitening off/FIFO Packet mode/CRC enable
 
 	 
 //Freq 
 BurstWrite(FREQ2, FreqTable[0], 3); //915MHZ
 //Modem 
 SpiWriteByte(MDMCFG4, 0xD6);
 SpiWriteByte(MDMCFG3, 0x83);//2.4K
 //SpiWriteByte(MDMCFG2, 0x02);		//FSK/NRZ/16bitSync
 SpiWriteByte(MDMCFG2, 0x13);		//GSK/30/32bit Sync(Repeat auto SYN1,SYN0 byte)
 SpiWriteByte(MDMCFG1, 0x22);		//4ֽ Premable
 SpiWriteByte(MDMCFG0, 0xF8);
 //Dev	
 SpiWriteByte(DEVIATN, 0x43);		//35KHz
 //MS   
 SpiWriteByte(MCSM1, 0x3A);			//ǰģʽ
 SpiWriteByte(MCSM0, 0x18);
 SpiWriteByte(FOCCFG, 0x16);
 SpiWriteByte(BSCFG, 0x6C);
 SpiWriteByte(AGCTRL2, 0x03);
 SpiWriteByte(AGCTRL1, 0x40);
 SpiWriteByte(AGCTRL0, 0x91);
 SpiWriteByte(FREND1, 0x56);
 SpiWriteByte(FREND0, 0x10);
 SpiWriteByte(FSCAL3, 0xE9);
 SpiWriteByte(FSCAL2, 0x2A);
 SpiWriteByte(FSCAL1, 0x00);
 SpiWriteByte(FSCAL0, 0x1F);
 
 
 // 
 for(i=0;i<8;i++)						
  	patable[i] = PATable[0][0];	 //fre, PowerPA
 BurstWrite(PATABLE, patable, 8);	 
 
 SpiWriteStorbe(SCAL);          	//ҪУ׼
 for(i=0;i<10;i++)					//úƵʲ׼ȷ
 	SpiWriteStorbe(SNOP);





  
}

	
/************************************************
**SPI /д//д
************************************************/
/************************************************
**ƣSleep
**ܣSPWD(sleep command =0x39)
**Para
**ȡ״̬
************************************************/
void hc210_sleep(void)
{
  SpiWriteStorbe(SIDLE);	
  _nop_();
  _nop_();
  _nop_();
  _nop_();
  _nop_();
  SpiWriteStorbe(SPWD); //0x39 sleep power down
   _nop_();
  _nop_();
   _nop_();
  _nop_();
  nSEL = 1;
  SCK  = 0;
  MOSI  = 0;
  _nop_();
  _nop_();
 
	
	
}


  
/************************************************
**SPI /д//д
************************************************/
/************************************************
**ƣHalfSpiCmd
**ܣSPIд
**Para
**ȡ״̬
************************************************/
u8 HalfSpiCmd(u8 WrPara)								
{                                                       
 u8 cnt;  
 u8 status = 0;  
 
 nSEL   = 0;
 SCK    = 0;

 for(cnt=8;cnt!=0;cnt--)                      
 	{         
 	status <<= 1;		                                          
 	if(WrPara&0x80)                                   
		MOSI = 1;
 	else              
		MOSI = 0;
	SCK = 1;
	WrPara <<= 1; 	
	if(MISO)					//״̬
		status |= 0x01; 		                                	
	SCK = 0;
 	} 
 return(status); 			//״̬	
}         

/************************************************
ƣ	SpiReadByte
ܣ	SPI
	
ݣ	
************************************************/
u8 SpiReadByte(u8 adr)
{
 u8 i;
 u8 status = 0;
 for(i=200;i!=0;i--)		//ȴMISO
 	{
 	nSEL = 0;						
 	if(!MISO)				//MISOΪͱʾоƬReady		
 		break;
 	}
 if(i!=0)
 	{
 	HalfSpiCmd(adr|0x80);	//ַ 
	status = HalfSpiCmd(0);	//
	}
 SCK  = 0;
 MOSI  = 0;
 nSEL = 1;
 return(status);
}

/************************************************
ƣ	SpiWriteByte
ܣ	SPI
	
ݣ	
************************************************/
u8 SpiWriteByte(u8 adr, u8 WrPara)
{
 u8 i;
 u8 status;
 for(i=200;i!=0;i--)	//ȴMISO
 	{
 	nSEL = 0;						
 	if(!MISO)			//MISOΪͱʾоƬReady
 		break;
 	}
 if(i!=0)				
 	{
 	HalfSpiCmd(adr);	//дַ 
	status = HalfSpiCmd(WrPara);//д
	}	
 SCK  = 0;
 MOSI  = 0;
 nSEL = 1;
 return(status);
}

/******************************************************************************
**ƣBurstRead
**ܣȡFIFO(״̬)
**          ȡ8λݣע⣺ӦFIFOΪ8λʽ
**
**0򲻳ɹ ط0ɹDataBuf 
**ע	1. ַ0x30Ժֻ֧״̬Ĵ
               0xF0ʼ
			2. עƱ߽
******************************************************************************/
u8 BurstRead(u8 adr, u8 *ptr, u8 length)
{
 u8 i; 
 
 u8 status = 0;
 
 if(length<=1)			//ȡȲΪ01
 	return(0xFF);
 
 for(i=200;i!=0;i--)	//ȴMISO
 	{
 	nSEL = 0;						
 	if(!MISO)			//MISOΪͱʾоƬReady
 		break;
 	}
 	
 if(i!=0)
	{
 	status = HalfSpiCmd(adr|0xC0);	//
 	for(i=0;i<length;i++)
 	 	ptr[i] = HalfSpiCmd(0xFF);
 	 }
 nSEL = 1; 	
 return(status);
}

/************************************************
ƣ	BurstWrite
ܣ	дĴ
	adr:     дĴַ
		 lenght:	1ȡ>1ȡ
				        0˳
ݣ	0򲻳ɹ ط0ɹDataBuf 
ע		1. ַ0x30Ժ󣬲
			2. עƱ߽
************************************************/
u8 BurstWrite(u8 adr, u8 const *ptr, u8 length)
{ 
 u8 i;
 u8 status=0;
 
 if(length<=1)			//ȡȲΪ01
 	return(0xFF);

 for(i=200;i!=0;i--)	//ȴMISO
 	{
 	nSEL = 0;						
 	if(!MISO)			//MISOΪͱʾоƬReady
 		break;
 	}
 if(i!=0)
 	{
 	HalfSpiCmd(adr|0x40);	//д
 	for(i=0;i<length;i++)
 	 	HalfSpiCmd(ptr[i]);
 	}	
 MOSI  = 0;
 nSEL = 1;
 return(status);
}

/************************************************
**CC1101ֱģʽ
************************************************/
/************************************************
ƣ	SpiWriteStorbe
ܣ	SPIֱģʽ
	
ݣ	
************************************************/
void SpiWriteStorbe(u8 strobe)
{
 u8 i;
 for(i=200;i!=0;i--)	//ȴMISO
 	{
 	nSEL = 0;			//MISOΪͱʾоƬReady			
 	if(!MISO)
 		break;
 	}
 if(i!=0)
 	HalfSpiCmd(strobe);
 SCK  = 0;
 MOSI  = 0;
 nSEL = 1;
}



/**********************************************************
ƣTestTxMode
ܣģʽ
**********************************************************/
void TestTxMode (void)
{
        SetCC1101();
 	//TX	
	SpiWriteStorbe(SIDLE);
 	
  	//SYNC 
 	
        //BurstWrite(SYNC1, SyncTable, 2);
 	
 
        //SpiWriteStorbe(SFTX);		//FIFO
	//SpiWriteByte(IOCFG2, 0x02);	//
	SpiWriteByte(FIFOTHR, 0x0F);//ʣ1ֽʾ	
	SpiWriteByte(PKTCTRL0, 0x0c);//PH+FIFO / fix Len / enable CRC
	//BurstWrite(TXFIFO, TxData, PKLENGTH+1);	
	
 	//SpiWriteStorbe(STX);		//ģʽ  
  	//while(nIRQ);				//ȴ
 	//SpiWriteStorbe(SIDLE);
 
 //BurstWrite(TXFIFO, TstData, 16);		
 SpiWriteStorbe(STX);				//ģʽ
 //Delayn(100);
 //BurstWrite(TXFIFO, TstData, 16);			
 //Delayn(100);
 SpiWriteStorbe(SIDLE); 
 //Delayn(10);
}

/**********************************************************
**Name:     HC213_RxPacket
**Function: Check for receive one packet
**Input:    none
**Output:  

//GFSK, var Length, 4 SYNC byte(hardware default value2 bytes , enable repeat as 4bytes)
//Auto 16-bit CRC,
//CC1101 or CC113, CRC OK for GPIO0,let packet it var length!!!, 
//output: 

    //txbuf   [0]          [1]           [2]  [3]  [4]       [5]
	        // |            |             |    |    |         |
	        //(length=5) (cmd /chno /idh )(idm)(idl)(level)(TransID/Mode)
	        //           b7-b4/b3b2 /b1b0                   b7-b4  /b3-b0

**********************************************************/
void HC210_RxPacket(void)
{
  unsigned char i; 
 
  if(GPIO0==1)
  {
             for(i=0;i<10;i++) 
                 gb_RxData[i] = 0x00;
             Delayn(5);
             //read PKTSTATUS
             //gb_Temp[0]=SpiReadByte(PKTSTATUS);//bit7=1 CRC_OK
             	       			
             SpiWriteStorbe(SIDLE);		//ȴ
             		
             BurstRead(RXFIFO, gb_RxData, PKLENGTH+2);//PKLENGTH=6
 	       		
             SpiWriteStorbe(SFRX);		//FIFO
             SpiWriteStorbe(SIDLE);		//ȴ			
             
             _nop_();
             _nop_();


             if(gb_RxData[0]!=5)
               goto Rx_packet_err;
 
              gb_rf_windows=c_rfwindows;


	      /*
             SendOut(0x55);
             SendOut(gb_RxData[0]);        //Length value 
             
             SendOut(gb_RxData[1]);	//CMD/CHNO/IDH //cmd(b7-b4)=0000
             SendOut(gb_RxData[2]);	//IDM
             SendOut(gb_RxData[3]);	//IDL             
             SendOut(gb_RxData[4]);	//Level
             
             SendOut(gb_RxData[5]);	//tran-ID/mode
             */

     
 
   }  
Rx_packet_err:;          
}                  


//===========================================================
//=====================================
// RATE=2.4kbps, each bit=416us, each byte=3.328ms
//4 BYTES AA, 4 BYTES SYNC, 6 BYTES DATA, 2 BYTES CRC,=16BYTES
// SO 53.248MS each packet
void tx_signal(void)
{
   if(f_en_tx==1)
   {
      switch(tx_step)
      {
    	case 0:
   	     	InitCC1101();
         	SetCC1101();
         
         	idh&=0x03;
	   
	        
	        transID+=0X10;
	        transID&=0XF0;  //(high-nibble)
	    
	        //txbuf   [0]          [1]           [2]  [3]  [4]       [5]
	        //         |            |             |    |    |         |
	        //      (length=5) (cmd /chno /idh )(idm)(idl)(level)(TransID/Mode)
	        //                 b7-b4/b3b2 /b1b0                   b7-b4  /b3-b0
	        //id=18bit
	        txbuf[0]=5; //length
	        txbuf[1]=ch_no<<2;
	        txbuf[1]&=0x0c; //0000 1100	       
	        txbuf[1]|=idh;
	        txbuf[2]=idm;
	        txbuf[3]=idl;
	        txbuf[4]=acmo_level;
            
            
	        txbuf[5]=gb_mode;
	             
	        txbuf[5]|=transID;
         	
	        SpiWriteStorbe(SIDLE);
	     	SpiWriteStorbe(SFTX);
	     	BurstWrite(TXFIFO, txbuf, 6);				
         	SpiWriteStorbe(STX);//tx time 55ms
		    //load 60ms Timer_Init  
		    tx_packet_time=32;//64ms
		   
		    txpoint=180;
		    tx_step=5; //only let it waiting
		    //tx_step=0; //only let it waiting
		    
		    //Delayn(80);
		 	break;
	    case 1:
	        SpiWriteStorbe(SIDLE);
	     	SpiWriteStorbe(SFTX);
	     	BurstWrite(TXFIFO, txbuf, 6);				
         	SpiWriteStorbe(STX);;
         	//load 60ms
         	tx_step=5; //only let it waiting
         	tx_packet_time=32;//64ms
         
            txpoint--; //frame no
            if(txpoint<1)
            {
            	f_en_tx=0;
            	SpiWriteStorbe(SIDLE);		//wait
            	tx_packet_time=0;
            	tx_packet_time=0;
            	SpiWriteStorbe(SIDLE); 
                Delayn(2);
            	hc210_sleep();
            }
         	break;
        default:
            break;
      }
	     

   }

}    